<template>
  <div class="row">
    <div class="col-lg-6 m-auto">
      <b-card :title="$t('register')">
        <form @submit.prevent="register" @keydown="form.onKeydown($event)">
          <!-- Name -->
          <div class="form-group row">
            <label class="col-md-12 col-form-label">{{ $t('name') }}</label>
            <div class="col-md-12">
              <input v-model="form.name" :class="{ 'is-invalid': form.errors.has('name') }" class="form-control" type="text" name="name">
              <has-error :form="form" field="name" />
            </div>
          </div>

          <!-- Jabber -->
          <div class="form-group row">
            <label class="col-md-12 col-form-label">{{ $t('jabber') }}</label>
            <div class="col-md-12">
              <input v-model="form.jabber" :class="{ 'is-invalid': form.errors.has('jabber') }" class="form-control" type="text" name="jabber">
              <has-error :form="form" field="jabber" />
            </div>
          </div>

          <!-- Password -->
          <div class="form-group row">
            <label class="col-md-12 col-form-label">{{ $t('password') }}</label>
            <div class="col-md-12">
              <input v-model="form.password" :class="{ 'is-invalid': form.errors.has('password') }" class="form-control" type="password" name="password">
              <has-error :form="form" field="password" />
            </div>
          </div>

          <!-- Password Confirmation -->
          <div class="form-group row">
            <label class="col-md-12 col-form-label">{{ $t('confirm_password') }}</label>
            <div class="col-md-12">
              <input v-model="form.password_confirmation" :class="{ 'is-invalid': form.errors.has('password_confirmation') }" class="form-control" type="password" name="password_confirmation">
              <has-error :form="form" field="password_confirmation" />
            </div>
          </div>

          <div class="form-group row">
            <div class="col-md-12 d-flex">
              <!-- Submit Button -->
              <v-button :loading="form.busy" block>
                {{ $t('register') }}
              </v-button>
            </div>
          </div>
        </form>
      </b-card>
    </div>
  </div>
</template>

<script>
import Form from 'vform'

export default {
  middleware: 'guest',

  metaInfo () {
    return { title: this.$t('register') }
  },

  data: () => ({
    form: new Form({
      name: '',
      jabber: '',
      password: '',
      password_confirmation: ''
    }),
    mustVerifyEmail: false
  }),

  methods: {
    async register () {
      // Register the user.
      const { data } = await this.form.post(route('shop.auth.register'))

      // Must verify email fist.
      if (data.status) {
        this.mustVerifyEmail = true
      } else {
        // Log in the user.
        const { data: { token } } = await this.form.post(route('shop.auth.login'))

        // Save the token.
        this.$store.dispatch('auth/saveToken', { token })

        // Update the user.
        await this.$store.dispatch('auth/updateUser', { user: data })

        // Redirect home.
        this.$router.push({ name: 'home' })
      }
    }
  }
}
</script>
